#!/usr/bin/env python
# encoding: utf-8
"""
receiver.py

Abstraction for a single conversation on the client application.

Created by Elliot Pennington 2008-12-11 
Edited by Gregory Sheaffer
"""

import sys, threading, Queue
import message

class Receiver():
    """ 
    Right now, this is complicated.
    """
    
    def __init__(self, sn, queue, r_event, insert, config):
        """
        Instantiate a new conversation.
        
        For testing purposes, just print the first message on the queue and die
        """
#        self.txt = Text(master, padx = 10, pady = 10, width = 65, height = 20)
#        self.txt.pack(side=TOP)
        self.insert = insert
        self.config = config
        self._sn = sn
        self.queue = queue
        self.r_event = r_event
#        self.print_it()
        print "%s reciever wait q ing" % self._sn
        self.wait_queue()
        
    def wait_queue(self):
        """
        Print things from the queue!
        """
        while 1:
            self.r_event.wait()
            self.print_it()
            
                
    def print_it(self):
        while not self.queue.empty():
            try:
                import Tkconstants
                str = self._sn + ": " + self.queue.get(True) + "\n"
                self.config(state = Tkconstants.NORMAL)
                self.insert(Tkconstants.END, str)
                self.config(state = Tkconstants.DISABLED)
                print "%s reciever event" % self._sn
                print str
                self.queue.task_done()
            except Queue.Empty:
                print "qe"
                break
